﻿assert( Postal, "Postal not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Postal")

local mailIndex = nil
local button = nil

local noop = function() end
local openAll = function() this.owner:OpenAll() end

----------------------------------
--      Module Declaration      --
----------------------------------

Postal_OpenAll = Postal:NewModule("OpenAll")
Postal_OpenAll.revision = tonumber(string.sub("$Revision: 43378 $", 12, -3))

function Postal_OpenAll:OnEnable()
	if not button then
		button = CreateFrame("Button", "PostalOpenAllButton", InboxFrame, "UIPanelButtonTemplate")
		button:SetWidth(120)
		button:SetHeight(25)
		button:SetPoint("CENTER", InboxFrame, "TOP", -15, -410)
		button:SetText(L["Open All"])
		button.owner = self
		button:SetScript("OnClick", openAll)
	end
	self:RegisterEvent("MAIL_CLOSED", "Reset")
	self:RegisterEvent("PLAYER_LEAVING_WORLD", "Reset")
end

function Postal_OpenAll:OpenAll()
	mailIndex = GetInboxNumItems()
	if not mailIndex or mailIndex == 0 then
		return
	else
		mailIndex = mailIndex + 1
	end

	button:SetScript("OnClick", noop)
	button:SetText(L["In Progress"])

	self:RegisterEvent("Postal_OpenAll_Next", "ProcessNext")
	Postal_OpenAll:ProcessNext()

end

function Postal_OpenAll:ProcessNext()
	self.core:DisableInbox(1)
	if mailIndex and mailIndex > 1 then
		mailIndex = mailIndex - 1
		local msgSubject = select(4, GetInboxHeaderInfo(mailIndex))
		self.core:Print(L["Processing Message"].." "..mailIndex..": "..msgSubject)
		self:SnarfMail(mailIndex)
	else
		if IsAddOnLoaded("MrPlow") then MrPlow:ParseInventory() end
		if GetInboxNumItems() then self.core:Print(L["Some Messages May Have Been Skipped."]) end
		self:Reset()
	end
end

function Postal_OpenAll:Reset()
	mailIndex = 0
	if self:IsEventRegistered("Postal_OpenAll_Next") then
		self:UnregisterEvent("Postal_OpenAll_Next")
	end
	if self:IsEventRegistered("MAIL_INBOX_UPDATE") then
		self:UnregisterEvent("MAIL_INBOX_UPDATE")
	end
	if self:IsEventRegistered("BAG_UPDATE") then
		self:UnregisterEvent("BAG_UPDATE")
	end
	button:SetScript("OnClick", openAll)
	button:SetText(L["Open All"])
	self.core:DisableInbox()
        CheckInbox()
	InboxFrame_Update()
end

function Postal_OpenAll:SnarfMail()
	local msgSubject, msgMoney, msgCOD, _, msgItem, _, _, msgText = select(4, GetInboxHeaderInfo(mailIndex))

	if msgCOD and msgCOD > 0 then self:TriggerEvent("Postal_OpenAll_Next") return end

	if msgItem then
		if not self.core:SpaceCheck() then
			self.core:Print(L["Skipping"].." "..mailIndex..": "..L["Insufficient Bag Space"])
			self:TriggerEvent("Postal_OpenAll_Next")
			return
		end
		-- self.core:Print("Getting Item from Message "..mailIndex)
		self:RegisterEvent("MAIL_INBOX_UPDATE")
		TakeInboxItem(mailIndex)
	elseif msgMoney > 0 then
	--	self.core:Print("Looting Message "..mailIndex)
		self:RegisterEvent("MAIL_INBOX_UPDATE")
		TakeInboxMoney(mailIndex)
	else
	--	self.core:Print("Deleting Message "..mailIndex)
		self:RegisterEvent("MAIL_INBOX_UPDATE")
		DeleteInboxItem(mailIndex)
	end
end

function Postal_OpenAll:MAIL_INBOX_UPDATE()
	--self.core:Print("update")
	self:UnregisterEvent("MAIL_INBOX_UPDATE")
	self:ScheduleEvent("Postal_OpenAll_Next", .5)
	if not HasNewMail()then
		MiniMapMailFrame:Hide()
	end
end
